/* Tabela PRATO: Prato */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela PRATO */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela Prato,
             utilizando a tabela Geral de Logs de Operaes */
CREATE OR REPLACE TRIGGER LOG_PLA_PRATO
AFTER DELETE OR INSERT OR UPDATE
ON PRATO FOR EACH ROW
DECLARE
  V_USUARIO   VARCHAR2(40);
  V_TIPO      VARCHAR2(1);
  V_ITPESQ    VARCHAR2(40);
  V_DESC      VARCHAR2(500);
  V_DTOPER    DATE;
  V_DSIP       VARCHAR2(50);
  V_DSUSUARIO  VARCHAR2(50);
  V_DSRDM      VARCHAR2(50);
  V_DSMETODO   VARCHAR2(250);
  V_DSOPERADOR VARCHAR2(12);
BEGIN
   V_TIPO := '0';
   V_DESC := '';
   WEBTUNNING(V_DSIP,
              V_DSUSUARIO,
              V_DSRDM,
              V_DSMETODO,
              V_DSOPERADOR);
   IF DELETING THEN
      V_DESC := V_DESC || 'Prato=' || :OLD.CDPRATO;
      V_DESC := V_DESC || ' Arv=' || :OLD.CDFILAUXPRAT;
      IF (NVL(:OLD.CDFILIAL, '') <> '') THEN
         V_DESC := V_DESC || ' Fili=' || :OLD.CDFILIAL;
      END IF;
      IF (NVL(:OLD.IDATIVO, '') <> '') THEN
         V_DESC := V_DESC || ' IdAtivo=' || :OLD.IDATIVO;
      END IF;        
      V_DESC := V_DESC || ' Nome=' || :OLD.NMPRATO;
      V_DESC := V_DESC || ' Nvel=' || :OLD.CDNVPRATO;
      IF (NVL(:OLD.SGUNIDADE, '') <> '') THEN
         V_DESC := V_DESC || ' Un=' || :OLD.SGUNIDADE;
      END IF;
      IF (NVL(:OLD.VRARREDTRANS, -1) <> -1) THEN
         V_DESC := V_DESC || ' ArredTrans=' || :OLD.VRARREDTRANS;
      END IF;
      IF (NVL(:OLD.CDSEGMER, '') <> '') THEN
         V_DESC := V_DESC || ' SegMerc=' || :OLD.CDSEGMER;
      END IF;
      V_DESC := V_DESC || ' Rdm='      || V_DSRDM;
      V_DESC := V_DESC || ' Mtodo='   || V_DSMETODO;
      V_DESC := V_DESC || ' Ip='       || V_DSIP;
      V_DESC := V_DESC || ' Usurio='  || V_DSUSUARIO;
      V_DESC := V_DESC || ' Operador=' || V_DSOPERADOR;
      V_TIPO := '3';
      V_ITPESQ := :OLD.CDPRATO||:OLD.CDFILAUXPRAT;
   ELSE
      IF UPDATING THEN
         IF (:OLD.CDPRATO      <> :NEW.CDPRATO     ) OR
            (:OLD.NMPRATO      <> :NEW.NMPRATO     ) OR
            (:OLD.CDNVPRATO    <> :NEW.CDNVPRATO   ) OR
            (:OLD.CDFILAUXPRAT <> :NEW.CDFILAUXPRAT) OR
            (NVL(:OLD.CDFILIAL,    '') <> NVL(:NEW.CDFILIAL,    '')) OR
            (NVL(:OLD.SGUNIDADE,   '') <> NVL(:NEW.SGUNIDADE,   '')) OR
            (NVL(:OLD.CDSEGMER,    '') <> NVL(:NEW.CDSEGMER,    '')) OR
            (NVL(:OLD.IDATIVO,    '') <> NVL(:NEW.IDATIVO,    '')) OR
            (NVL(:OLD.VRARREDTRANS, -1) <> NVL(:NEW.VRARREDTRANS, -1)) THEN
            V_TIPO   := '2';
            V_ITPESQ := :OLD.CDPRATO||:OLD.CDFILAUXPRAT;
         END IF;
      ELSE
         V_TIPO   := '1';
         V_ITPESQ := :NEW.CDPRATO||:NEW.CDFILAUXPRAT;
      END IF;
      IF UPDATING THEN
         IF (:OLD.CDPRATO <> :NEW.CDPRATO) THEN
            V_DESC := V_DESC || 'Prato=' || :OLD.CDPRATO || '|' || :NEW.CDPRATO;
         ELSE
            V_DESC := V_DESC || 'Prato=' || :OLD.CDPRATO;
         END IF;
      ELSE
         V_DESC := V_DESC || 'Prato=' || :NEW.CDPRATO;
      END IF;
      IF UPDATING THEN
         IF (:OLD.CDFILAUXPRAT <> :NEW.CDFILAUXPRAT) THEN
            V_DESC := V_DESC || ' Arv=' || :OLD.CDFILAUXPRAT || '|' || :NEW.CDFILAUXPRAT;
         ELSE
            V_DESC := V_DESC || ' Arv=' || :OLD.CDFILAUXPRAT;
         END IF;
      ELSE
         V_DESC := V_DESC || ' Arv=' || :NEW.CDFILAUXPRAT;
      END IF;
      IF (NVL(:NEW.CDFILIAL, '') <> '') OR (UPDATING AND (NVL(:NEW.CDFILIAL, '') = '')) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.CDFILIAL, '') <> NVL(:NEW.CDFILIAL, '')) THEN
               V_DESC := V_DESC || ' Fili de=' || :OLD.CDFILIAL || ' para=' || :NEW.CDFILIAL;
            END IF;
         ELSE
            V_DESC := V_DESC || ' Fili=' || :NEW.CDFILIAL;
         END IF;
      END IF;
      IF UPDATING THEN
         IF (:OLD.IDATIVO <> :NEW.IDATIVO) THEN
            V_DESC := V_DESC || ' IdAtivo=' || :OLD.IDATIVO || '|' || :NEW.IDATIVO;
         ELSE
            V_DESC := V_DESC || ' IdAtivo=' || :OLD.IDATIVO;
         END IF;
      ELSE
         V_DESC := V_DESC || ' IdAtivo=' || :NEW.IDATIVO;
      END IF;     
      IF UPDATING THEN
         IF (:OLD.NMPRATO <> :NEW.NMPRATO) THEN
            V_DESC := V_DESC || ' Nome de=' || :OLD.NMPRATO || ' para=' || :NEW.NMPRATO;
         END IF;
      ELSE
         V_DESC := V_DESC || ' Nome=' || :NEW.NMPRATO;
      END IF;
      IF UPDATING THEN
         IF (:OLD.CDNVPRATO <> :NEW.CDNVPRATO) THEN
            V_DESC := V_DESC || ' Nvel de=' || :OLD.CDNVPRATO || ' para=' || :NEW.CDNVPRATO;
         END IF;
      ELSE
         V_DESC := V_DESC || ' Nvel=' || :NEW.CDNVPRATO;
      END IF;
      IF (NVL(:NEW.SGUNIDADE, '') <> '') OR (UPDATING AND (NVL(:NEW.SGUNIDADE, '') = '')) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.SGUNIDADE, '') <> NVL(:NEW.SGUNIDADE, '')) THEN
               V_DESC := V_DESC || ' Un de=' || :OLD.SGUNIDADE || ' para=' || :NEW.SGUNIDADE;
            END IF;
         ELSE
            V_DESC := V_DESC || ' Un=' || :NEW.SGUNIDADE;
         END IF;
      END IF;
      IF (NVL(:NEW.VRARREDTRANS, -1) <> -1) OR (UPDATING AND (NVL(:NEW.VRARREDTRANS, -1) = -1)) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.VRARREDTRANS, -1) <> NVL(:NEW.VRARREDTRANS, -1)) THEN
               V_DESC := V_DESC || ' ArredTrans de=' || :OLD.VRARREDTRANS || ' para=' || :NEW.VRARREDTRANS;
            END IF;
         ELSE
            V_DESC := V_DESC || ' ArredTrans=' || :NEW.VRARREDTRANS;
         END IF;
      END IF;
      IF (NVL(:NEW.CDSEGMER, '') <> '') OR (UPDATING AND (NVL(:NEW.CDSEGMER, '') = '')) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.CDSEGMER, '') <> NVL(:NEW.CDSEGMER, '')) THEN
               V_DESC := V_DESC || ' SegMerc de=' || :OLD.CDSEGMER || ' para=' || :NEW.CDSEGMER;
            END IF;
         ELSE
            V_DESC := V_DESC || ' SegMerc=' || :NEW.CDSEGMER;
         END IF;
      END IF;
      V_DESC := V_DESC || ' Rdm='      || V_DSRDM;
      V_DESC := V_DESC || ' Mtodo='   || V_DSMETODO;
      V_DESC := V_DESC || ' Ip='       || V_DSIP;
      V_DESC := V_DESC || ' Usurio='  || V_DSUSUARIO;
      V_DESC := V_DESC || ' Operador=' || V_DSOPERADOR;
   END IF;
   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;

            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER, IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER, CDFILLOGOPER)
            VALUES
               ('PRATO', V_DTOPER, V_USUARIO, V_TIPO, V_ITPESQ, SUBSTR(V_DESC, 1, 300),
                V_DSRDM, V_DSIP, V_DSUSUARIO, V_DSMETODO, V_DSOPERADOR, NVL(:NEW.CDFILIAL, :OLD.CDFILIAL));
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_PLA_PRATO','6.35.019'); END;
/
